//      IRQ    
//   1     EINT0,   
//    EINT1     
// , , 
#include <LPC213x.h>
void IRQ_EINT0(void) __irq;
void IRQ_EINT1(void) __irq;

//    /   
//      /     								  
#define IENABLE                /*     */	 \
  __asm { MRS     LR, SPSR      };    /*  SPSR_irq  LR 	 */	 \
  __asm { STMFD   SP!, {LR}     };    /*  SPSR_irq			 */	 \
  __asm { MSR     CPSR_c, #0x1F };    /*  IRQ (Sys Mode) 	 */	 \
  __asm { STMFD   SP!, {LR}     };    /*  LR                */	 \
  					   

#define IDISABLE                /*    	*/	 \
  __asm { LDMFD   SP!, {LR}     }     /*  LR        		*/	 \
  __asm { MSR     CPSR_c, #0x92 }     /*  IRQ (IRQ Mode)		*/	 \
  __asm { LDMFD   SP!, {LR}     }     /*  SPSR_irq  LR  	*/	 \
  __asm { MSR     SPSR_cxsf, LR }     /*  LR  SPSR_irq  	*/	 \
						

void main(void) {
//   -
PINSEL0=0x000000CC;			//   P0.1   EINT0	, P0.3   EINT1
IODIR0 =0x00000001;    		//   P0.0  
IOSET0 =0x00000001;	   		//   P0.0

//   
EXTMODE=0x03;				//   EINT0, EINT1   
EXTPOLAR=0x00;				//   EINT0, EINT1   

//   
VICIntSelect    = 0x00;					//   FIQ 
VICVectCntl0 	= 0x020 + 14;  			//   0 +    IENT0
VICVectCntl1 	= 0x020 + 15;  			//   1 +    IENT1
VICVectAddr0 	= (unsigned)IRQ_EINT0;	//     EINT0
VICVectAddr1 	= (unsigned)IRQ_EINT1;	//     EINT0
VICIntEnable    =  0x04000+0x08000;		//    EINT0 + EINT1 

while (1) {};				//  

}

void IRQ_EINT0(void)  __arm	__irq	// 
{
	EXTINT=0x01;    				//      EINT0
	//    ,        !

	IENABLE; 						//   
	//   .      .

	IOCLR0=0x00000001;	  			//  

	while (!(IOPIN0&04)) {};		//    -  !
	//  ,       
	//      !

	IDISABLE;						//   
  	
  	VICVectAddr 	= 0x00000000;	//   
}

void IRQ_EINT1(void) __arm __irq
{
	IOSET0=0x00000001;	  			//  
  	EXTINT=0x02;    				//      EINT1
  	VICVectAddr 	= 0x00000000;	//   
}
 

